! wrapfgeneric.f
! This file is generated by Shroud nowrite-version. Do not edit.
! Copyright (c) 2017-2023, Lawrence Livermore National Security, LLC and
! other Shroud Project Developers.
! See the top-level COPYRIGHT file for details.
!
! SPDX-License-Identifier: (BSD-3-Clause)
!
!>
!! \file wrapfgeneric.f
!! \brief Shroud generated wrapper for generic library
!<
! splicer begin file_top
! splicer end file_top
module generic_mod
    use iso_c_binding, only : C_INT, C_LONG, C_NULL_PTR, C_PTR, C_SIZE_T
    ! splicer begin module_use
    ! splicer end module_use
    implicit none

    ! splicer begin module_top
    integer, parameter :: T_INT = 1
    integer, parameter :: T_LONG = 2
    integer, parameter :: T_FLOAT = 3
    integer, parameter :: T_DOUBLE = 4
    ! splicer end module_top

    ! helper ShroudTypeDefines
    ! Shroud type defines from helper ShroudTypeDefines
    integer, parameter, private :: &
        SH_TYPE_SIGNED_CHAR= 1, &
        SH_TYPE_SHORT      = 2, &
        SH_TYPE_INT        = 3, &
        SH_TYPE_LONG       = 4, &
        SH_TYPE_LONG_LONG  = 5, &
        SH_TYPE_SIZE_T     = 6, &
        SH_TYPE_UNSIGNED_SHORT      = SH_TYPE_SHORT + 100, &
        SH_TYPE_UNSIGNED_INT        = SH_TYPE_INT + 100, &
        SH_TYPE_UNSIGNED_LONG       = SH_TYPE_LONG + 100, &
        SH_TYPE_UNSIGNED_LONG_LONG  = SH_TYPE_LONG_LONG + 100, &
        SH_TYPE_INT8_T    =  7, &
        SH_TYPE_INT16_T   =  8, &
        SH_TYPE_INT32_T   =  9, &
        SH_TYPE_INT64_T   = 10, &
        SH_TYPE_UINT8_T  =  SH_TYPE_INT8_T + 100, &
        SH_TYPE_UINT16_T =  SH_TYPE_INT16_T + 100, &
        SH_TYPE_UINT32_T =  SH_TYPE_INT32_T + 100, &
        SH_TYPE_UINT64_T =  SH_TYPE_INT64_T + 100, &
        SH_TYPE_FLOAT       = 22, &
        SH_TYPE_DOUBLE      = 23, &
        SH_TYPE_LONG_DOUBLE = 24, &
        SH_TYPE_FLOAT_COMPLEX      = 25, &
        SH_TYPE_DOUBLE_COMPLEX     = 26, &
        SH_TYPE_LONG_DOUBLE_COMPLEX= 27, &
        SH_TYPE_BOOL      = 28, &
        SH_TYPE_CHAR      = 29, &
        SH_TYPE_CPTR      = 30, &
        SH_TYPE_STRUCT    = 31, &
        SH_TYPE_OTHER     = 32

    ! start helper capsule_data_helper
    ! helper capsule_data_helper
    type, bind(C) :: GEN_SHROUD_capsule_data
        type(C_PTR) :: addr = C_NULL_PTR  ! address of C++ memory
        integer(C_INT) :: idtor = 0       ! index of destructor
    end type GEN_SHROUD_capsule_data
    ! end helper capsule_data_helper

    ! start array_context
    ! helper array_context
    type, bind(C) :: GEN_SHROUD_array
        ! address of C++ memory
        type(GEN_SHROUD_capsule_data) :: cxx
        ! address of data in cxx
        type(C_PTR) :: base_addr = C_NULL_PTR
        ! type of element
        integer(C_INT) :: type
        ! bytes-per-item or character len of data in cxx
        integer(C_SIZE_T) :: elem_len = 0_C_SIZE_T
        ! size of data in cxx
        integer(C_SIZE_T) :: size = 0_C_SIZE_T
        ! number of dimensions
        integer(C_INT) :: rank = -1
        integer(C_LONG) :: shape(7) = 0
    end type GEN_SHROUD_array
    ! end array_context

    type struct_as_class
        type(GEN_SHROUD_capsule_data) :: cxxmem
        ! splicer begin class.StructAsClass.component_part
        ! splicer end class.StructAsClass.component_part
    contains
        procedure :: get_instance => struct_as_class_get_instance
        procedure :: set_instance => struct_as_class_set_instance
        procedure :: associated => struct_as_class_associated
        ! splicer begin class.StructAsClass.type_bound_procedure_part
        ! splicer end class.StructAsClass.type_bound_procedure_part
    end type struct_as_class

    interface operator (.eq.)
        module procedure struct_as_class_eq
    end interface

    interface operator (.ne.)
        module procedure struct_as_class_ne
    end interface

    ! ----------------------------------------
    ! Function:  void UpdateAsFloat
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float arg +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_update_as_float(arg) &
                bind(C, name="UpdateAsFloat")
            use iso_c_binding, only : C_FLOAT
            implicit none
            real(C_FLOAT), value, intent(IN) :: arg
        end subroutine c_update_as_float
    end interface

    ! ----------------------------------------
    ! Function:  void UpdateAsDouble
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  double arg +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_update_as_double(arg) &
                bind(C, name="UpdateAsDouble")
            use iso_c_binding, only : C_DOUBLE
            implicit none
            real(C_DOUBLE), value, intent(IN) :: arg
        end subroutine c_update_as_double
    end interface

    ! ----------------------------------------
    ! Function:  double GetGlobalDouble
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    interface
        function get_global_double() &
                result(SHT_rv) &
                bind(C, name="GetGlobalDouble")
            use iso_c_binding, only : C_DOUBLE
            implicit none
            real(C_DOUBLE) :: SHT_rv
        end function get_global_double
    end interface

    ! ----------------------------------------
    ! Function:  void GenericReal
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  double arg +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! start c_generic_real
    interface
        subroutine c_generic_real(arg) &
                bind(C, name="GenericReal")
            use iso_c_binding, only : C_DOUBLE
            implicit none
            real(C_DOUBLE), value, intent(IN) :: arg
        end subroutine c_generic_real
    end interface
    ! end c_generic_real

    ! ----------------------------------------
    ! Function:  long GenericReal2
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  long arg1 +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  long arg2 +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_generic_real2(arg1, arg2) &
                result(SHT_rv) &
                bind(C, name="GenericReal2")
            use iso_c_binding, only : C_LONG
            implicit none
            integer(C_LONG), value, intent(IN) :: arg1
            integer(C_LONG), value, intent(IN) :: arg2
            integer(C_LONG) :: SHT_rv
        end function c_generic_real2
    end interface

    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_sum_values(values, nvalues) &
                result(SHT_rv) &
                bind(C, name="SumValues")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: values
            integer(C_INT), value, intent(IN) :: nvalues
            integer(C_INT) :: SHT_rv
        end function c_sum_values
    end interface

    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(0)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_sum_values_0d(values, nvalues) &
                result(SHT_rv) &
                bind(C, name="GEN_SumValues_0d")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: values
            integer(C_INT), value, intent(IN) :: nvalues
            integer(C_INT) :: SHT_rv
        end function c_sum_values_0d
    end interface

    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(1)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_sum_values_1d(values, nvalues) &
                result(SHT_rv) &
                bind(C, name="GEN_SumValues_1d")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: values(*)
            integer(C_INT), value, intent(IN) :: nvalues
            integer(C_INT) :: SHT_rv
        end function c_sum_values_1d
    end interface

    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(2)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_sum_values_2d(values, nvalues) &
                result(SHT_rv) &
                bind(C, name="GEN_SumValues_2d")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: values(*)
            integer(C_INT), value, intent(IN) :: nvalues
            integer(C_INT) :: SHT_rv
        end function c_sum_values_2d
    end interface

    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_assign_values(from, nfrom, to, nto) &
                bind(C, name="AssignValues")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: from
            integer(C_INT), value, intent(IN) :: nfrom
            integer(C_INT), intent(INOUT) :: to
            integer(C_INT), value, intent(IN) :: nto
        end subroutine c_assign_values
    end interface

    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_assign_values_scalar(from, nfrom, to, nto) &
                bind(C, name="GEN_AssignValues_scalar")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: from
            integer(C_INT), value, intent(IN) :: nfrom
            integer(C_INT), intent(INOUT) :: to
            integer(C_INT), value, intent(IN) :: nto
        end subroutine c_assign_values_scalar
    end interface

    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to +rank(1)
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_assign_values_broadcast(from, nfrom, to, nto) &
                bind(C, name="GEN_AssignValues_broadcast")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: from
            integer(C_INT), value, intent(IN) :: nfrom
            integer(C_INT), intent(INOUT) :: to(*)
            integer(C_INT), value, intent(IN) :: nto
        end subroutine c_assign_values_broadcast
    end interface

    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from +rank(1)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to +rank(1)
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_assign_values_copy(from, nfrom, to, nto) &
                bind(C, name="GEN_AssignValues_copy")
            use iso_c_binding, only : C_INT
            implicit none
            integer(C_INT), intent(IN) :: from(*)
            integer(C_INT), value, intent(IN) :: nfrom
            integer(C_INT), intent(INOUT) :: to(*)
            integer(C_INT), value, intent(IN) :: nto
        end subroutine c_assign_values_copy
    end interface

#if 1
    ! ----------------------------------------
    ! Function:  void SavePointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  void * addr +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_void_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer(addr, type, size) &
                bind(C, name="SavePointer")
            use iso_c_binding, only : C_INT, C_PTR, C_SIZE_T
            implicit none
            type(C_PTR), value, intent(IN) :: addr
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer
    end interface
#endif

#if 1
    ! ----------------------------------------
    ! Function:  void SavePointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(1)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +implied(T_FLOAT)+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer_float1d(addr, type, size) &
                bind(C, name="GEN_SavePointer_float1d")
            use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
            implicit none
            real(C_FLOAT), intent(IN) :: addr(*)
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer_float1d
    end interface
#endif

#if 1
    ! ----------------------------------------
    ! Function:  void SavePointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(2)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +implied(T_FLOAT)+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer_float2d(addr, type, size) &
                bind(C, name="GEN_SavePointer_float2d")
            use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
            implicit none
            real(C_FLOAT), intent(IN) :: addr(*)
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer_float2d
    end interface
#endif

    ! ----------------------------------------
    ! Function:  void SavePointer2
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  void * addr +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_void_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +implied(type(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer2(addr, type, size) &
                bind(C, name="GEN_SavePointer2")
            use iso_c_binding, only : C_INT, C_PTR, C_SIZE_T
            implicit none
            type(C_PTR), value, intent(IN) :: addr
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer2
    end interface

    ! ----------------------------------------
    ! Function:  void SavePointer2
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(1)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +implied(type(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer2_float1d(addr, type, size) &
                bind(C, name="GEN_SavePointer2_float1d")
            use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
            implicit none
            real(C_FLOAT), intent(IN) :: addr(*)
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer2_float1d
    end interface

    ! ----------------------------------------
    ! Function:  void SavePointer2
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(2)
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int type +implied(type(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t size +implied(size(addr))+value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        subroutine c_save_pointer2_float2d(addr, type, size) &
                bind(C, name="GEN_SavePointer2_float2d")
            use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
            implicit none
            real(C_FLOAT), intent(IN) :: addr(*)
            integer(C_INT), value, intent(IN) :: type
            integer(C_SIZE_T), value, intent(IN) :: size
        end subroutine c_save_pointer2_float2d
    end interface

    ! ----------------------------------------
    ! Function:  void GetPointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  void * * addr +intent(out)
    ! Attrs:     +intent(out)
    ! Exact:     c_out_void_**
    ! ----------------------------------------
    ! Argument:  int * type +intent(out)
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t * size +intent(out)
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    interface
        subroutine get_pointer(addr, type, size) &
                bind(C, name="GetPointer")
            use iso_c_binding, only : C_INT, C_PTR, C_SIZE_T
            implicit none
            type(C_PTR), intent(OUT) :: addr
            integer(C_INT), intent(OUT) :: type
            integer(C_SIZE_T), intent(OUT) :: size
        end subroutine get_pointer
    end interface

#if 0
    ! ----------------------------------------
    ! Function:  void GetPointerAsPointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  void * * addr +intent(out)
    ! Attrs:     +intent(out)
    ! Exact:     c_out_void_**
    ! ----------------------------------------
    ! Argument:  int * type +hidden+intent(out)
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t * size +hidden+intent(out)
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    interface
        subroutine c_get_pointer_as_pointer(addr, type, size) &
                bind(C, name="GetPointerAsPointer")
            use iso_c_binding, only : C_INT, C_PTR, C_SIZE_T
            implicit none
            type(C_PTR), intent(OUT) :: addr
            integer(C_INT), intent(OUT) :: type
            integer(C_SIZE_T), intent(OUT) :: size
        end subroutine c_get_pointer_as_pointer
    end interface
#endif

#if 0
    ! ----------------------------------------
    ! Function:  void GetPointerAsPointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * * addr +deref(pointer)+intent(out)+rank(1)
    ! Attrs:     +api(cdesc)+deref(pointer)+intent(out)
    ! Requested: c_out_native_**_cdesc_pointer
    ! Match:     c_out_native_**_cdesc
    interface
        subroutine c_get_pointer_as_pointer_float1d_bufferify( &
                SHT_addr_cdesc) &
                bind(C, name="GEN_GetPointerAsPointer_float1d_bufferify")
            import :: GEN_SHROUD_array
            implicit none
            type(GEN_SHROUD_array), intent(OUT) :: SHT_addr_cdesc
        end subroutine c_get_pointer_as_pointer_float1d_bufferify
    end interface
#endif

#if 0
    ! ----------------------------------------
    ! Function:  void GetPointerAsPointer
    ! Attrs:     +intent(subroutine)
    ! Requested: c_subroutine_void_scalar
    ! Match:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * * addr +deref(pointer)+intent(out)+rank(2)
    ! Attrs:     +api(cdesc)+deref(pointer)+intent(out)
    ! Requested: c_out_native_**_cdesc_pointer
    ! Match:     c_out_native_**_cdesc
    interface
        subroutine c_get_pointer_as_pointer_float2d_bufferify( &
                SHT_addr_cdesc) &
                bind(C, name="GEN_GetPointerAsPointer_float2d_bufferify")
            import :: GEN_SHROUD_array
            implicit none
            type(GEN_SHROUD_array), intent(OUT) :: SHT_addr_cdesc
        end subroutine c_get_pointer_as_pointer_float2d_bufferify
    end interface
#endif

    ! ----------------------------------------
    ! Function:  StructAsClass * CreateStructAsClass
    ! Attrs:     +api(capptr)+intent(function)
    ! Exact:     c_function_shadow_*_capptr
    interface
        function c_create_struct_as_class(SHT_rv) &
                result(SHT_prv) &
                bind(C, name="GEN_CreateStructAsClass")
            use iso_c_binding, only : C_PTR
            import :: GEN_SHROUD_capsule_data
            implicit none
            type(GEN_SHROUD_capsule_data), intent(OUT) :: SHT_rv
            type(C_PTR) :: SHT_prv
        end function c_create_struct_as_class
    end interface

    ! ----------------------------------------
    ! Function:  long UpdateStructAsClass
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  StructAsClass * arg
    ! Attrs:     +intent(inout)
    ! Exact:     c_inout_shadow_*
    ! ----------------------------------------
    ! Argument:  long inew +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_update_struct_as_class(arg, inew) &
                result(SHT_rv) &
                bind(C, name="GEN_UpdateStructAsClass")
            use iso_c_binding, only : C_LONG
            import :: GEN_SHROUD_capsule_data
            implicit none
            type(GEN_SHROUD_capsule_data), intent(INOUT) :: arg
            integer(C_LONG), value, intent(IN) :: inew
            integer(C_LONG) :: SHT_rv
        end function c_update_struct_as_class
    end interface

    ! ----------------------------------------
    ! Function:  long UpdateStructAsClass
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  StructAsClass * arg
    ! Attrs:     +intent(inout)
    ! Exact:     c_inout_shadow_*
    ! ----------------------------------------
    ! Argument:  int inew +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_update_struct_as_class_int(arg, inew) &
                result(SHT_rv) &
                bind(C, name="GEN_UpdateStructAsClass_int")
            use iso_c_binding, only : C_INT, C_LONG
            import :: GEN_SHROUD_capsule_data
            implicit none
            type(GEN_SHROUD_capsule_data), intent(INOUT) :: arg
            integer(C_INT), value, intent(IN) :: inew
            integer(C_LONG) :: SHT_rv
        end function c_update_struct_as_class_int
    end interface

    ! ----------------------------------------
    ! Function:  long UpdateStructAsClass
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  StructAsClass * arg
    ! Attrs:     +intent(inout)
    ! Exact:     c_inout_shadow_*
    ! ----------------------------------------
    ! Argument:  long inew +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    interface
        function c_update_struct_as_class_long(arg, inew) &
                result(SHT_rv) &
                bind(C, name="GEN_UpdateStructAsClass_long")
            use iso_c_binding, only : C_LONG
            import :: GEN_SHROUD_capsule_data
            implicit none
            type(GEN_SHROUD_capsule_data), intent(INOUT) :: arg
            integer(C_LONG), value, intent(IN) :: inew
            integer(C_LONG) :: SHT_rv
        end function c_update_struct_as_class_long
    end interface

    interface assign_values
        module procedure assign_values_scalar
        module procedure assign_values_broadcast
        module procedure assign_values_copy
    end interface assign_values

    ! start generic interface generic_real
    interface generic_real
        module procedure generic_real_float
        module procedure generic_real_double
    end interface generic_real
    ! end generic interface generic_real

    interface generic_real2
        module procedure generic_real2_all_int
        module procedure generic_real2_all_long
    end interface generic_real2

#if 0
    interface get_pointer_as_pointer
        module procedure get_pointer_as_pointer_float1d
        module procedure get_pointer_as_pointer_float2d
    end interface get_pointer_as_pointer
#endif

#if 1
    interface save_pointer
        module procedure save_pointer_float1d
        module procedure save_pointer_float2d
    end interface save_pointer
#endif

    interface save_pointer2
        module procedure save_pointer2_float1d
        module procedure save_pointer2_float2d
    end interface save_pointer2

    interface struct_as_class
        module procedure create_struct_as_class
    end interface struct_as_class

    interface sum_values
        module procedure sum_values_0d
        module procedure sum_values_1d
        module procedure sum_values_2d
    end interface sum_values

    interface update_real
        module procedure update_as_float
        module procedure update_as_double
    end interface update_real

    interface update_struct_as_class
        module procedure update_struct_as_class_int
        module procedure update_struct_as_class_long
    end interface update_struct_as_class

    ! splicer begin additional_declarations
    ! splicer end additional_declarations

contains

    ! Return pointer to C++ memory.
    function struct_as_class_get_instance(obj) result (cxxptr)
        use iso_c_binding, only: C_PTR
        class(struct_as_class), intent(IN) :: obj
        type(C_PTR) :: cxxptr
        cxxptr = obj%cxxmem%addr
    end function struct_as_class_get_instance

    subroutine struct_as_class_set_instance(obj, cxxmem)
        use iso_c_binding, only: C_PTR
        class(struct_as_class), intent(INOUT) :: obj
        type(C_PTR), intent(IN) :: cxxmem
        obj%cxxmem%addr = cxxmem
        obj%cxxmem%idtor = 0
    end subroutine struct_as_class_set_instance

    function struct_as_class_associated(obj) result (rv)
        use iso_c_binding, only: c_associated
        class(struct_as_class), intent(IN) :: obj
        logical rv
        rv = c_associated(obj%cxxmem%addr)
    end function struct_as_class_associated

    ! splicer begin class.StructAsClass.additional_functions
    ! splicer end class.StructAsClass.additional_functions

    ! ----------------------------------------
    ! Function:  void UpdateAsFloat
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float arg +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    subroutine update_as_float(arg)
        use iso_c_binding, only : C_FLOAT
        real(C_FLOAT), value, intent(IN) :: arg
        ! splicer begin function.update_as_float
        call c_update_as_float(arg)
        ! splicer end function.update_as_float
    end subroutine update_as_float

    ! ----------------------------------------
    ! Function:  void UpdateAsDouble
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  double arg +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    subroutine update_as_double(arg)
        use iso_c_binding, only : C_DOUBLE
        real(C_DOUBLE), value, intent(IN) :: arg
        ! splicer begin function.update_as_double
        call c_update_as_double(arg)
        ! splicer end function.update_as_double
    end subroutine update_as_double

#if 0
    ! Only the interface is needed
    ! ----------------------------------------
    ! Function:  double GetGlobalDouble
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    function get_global_double() &
            result(SHT_rv)
        use iso_c_binding, only : C_DOUBLE
        real(C_DOUBLE) :: SHT_rv
        ! splicer begin function.get_global_double
        SHT_rv = c_get_global_double()
        ! splicer end function.get_global_double
    end function get_global_double
#endif

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void GenericReal
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float arg +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Argument:  double arg +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief Single argument generic
    !!
    !<
    ! start generic_real_float
    subroutine generic_real_float(arg)
        use iso_c_binding, only : C_DOUBLE, C_FLOAT
        real(C_FLOAT), value, intent(IN) :: arg
        ! splicer begin function.generic_real_float
        call c_generic_real(real(arg, C_DOUBLE))
        ! splicer end function.generic_real_float
    end subroutine generic_real_float
    ! end generic_real_float

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void GenericReal
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  double arg +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief Single argument generic
    !!
    !<
    ! start generic_real_double
    subroutine generic_real_double(arg)
        use iso_c_binding, only : C_DOUBLE
        real(C_DOUBLE), value, intent(IN) :: arg
        ! splicer begin function.generic_real_double
        call c_generic_real(arg)
        ! splicer end function.generic_real_double
    end subroutine generic_real_double
    ! end generic_real_double

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  long GenericReal2
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  int arg1 +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Argument:  long arg1 +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int arg2 +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Argument:  long arg2 +value
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief Two argument generic
    !!
    !! It is not possible to call the function with (int, long)
    !! or (long, int)
    !<
    function generic_real2_all_int(arg1, arg2) &
            result(SHT_rv)
        use iso_c_binding, only : C_INT, C_LONG
        integer(C_INT), value, intent(IN) :: arg1
        integer(C_INT), value, intent(IN) :: arg2
        integer(C_LONG) :: SHT_rv
        ! splicer begin function.generic_real2_all_int
        SHT_rv = c_generic_real2(int(arg1, C_LONG), int(arg2, C_LONG))
        ! splicer end function.generic_real2_all_int
    end function generic_real2_all_int

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  long GenericReal2
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  long arg1 +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  long arg2 +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief Two argument generic
    !!
    !! It is not possible to call the function with (int, long)
    !! or (long, int)
    !<
    function generic_real2_all_long(arg1, arg2) &
            result(SHT_rv)
        use iso_c_binding, only : C_LONG
        integer(C_LONG), value, intent(IN) :: arg1
        integer(C_LONG), value, intent(IN) :: arg2
        integer(C_LONG) :: SHT_rv
        ! splicer begin function.generic_real2_all_long
        SHT_rv = c_generic_real2(arg1, arg2)
        ! splicer end function.generic_real2_all_long
    end function generic_real2_all_long

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(0)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief scalar or array argument using assumed rank
    !!
    !<
    function sum_values_0d(values, nvalues) &
            result(SHT_rv)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: values
        integer(C_INT), value, intent(IN) :: nvalues
        integer(C_INT) :: SHT_rv
        ! splicer begin function.sum_values_0d
        SHT_rv = c_sum_values_0d(values, nvalues)
        ! splicer end function.sum_values_0d
    end function sum_values_0d

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(1)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief scalar or array argument using assumed rank
    !!
    !<
    function sum_values_1d(values, nvalues) &
            result(SHT_rv)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: values(:)
        integer(C_INT), value, intent(IN) :: nvalues
        integer(C_INT) :: SHT_rv
        ! splicer begin function.sum_values_1d
        SHT_rv = c_sum_values_1d(values, nvalues)
        ! splicer end function.sum_values_1d
    end function sum_values_1d

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  int SumValues
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  const int * values +rank(2)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nvalues +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! \brief scalar or array argument using assumed rank
    !!
    !<
    function sum_values_2d(values, nvalues) &
            result(SHT_rv)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: values(:,:)
        integer(C_INT), value, intent(IN) :: nvalues
        integer(C_INT) :: SHT_rv
        ! splicer begin function.sum_values_2d
        SHT_rv = c_sum_values_2d(values, nvalues)
        ! splicer end function.sum_values_2d
    end function sum_values_2d

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to
    ! Attrs:     +intent(inout)
    ! Requested: f_inout_native_*
    ! Match:     f_default
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! Broadcast if nfrom == 1
    !! Copy if nfrom == nto
    !<
    subroutine assign_values_scalar(from, nfrom, to, nto)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: from
        integer(C_INT), value, intent(IN) :: nfrom
        integer(C_INT), intent(INOUT) :: to
        integer(C_INT), value, intent(IN) :: nto
        ! splicer begin function.assign_values_scalar
        call c_assign_values_scalar(from, nfrom, to, nto)
        ! splicer end function.assign_values_scalar
    end subroutine assign_values_scalar

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to +rank(1)
    ! Attrs:     +intent(inout)
    ! Requested: f_inout_native_*
    ! Match:     f_default
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! Broadcast if nfrom == 1
    !! Copy if nfrom == nto
    !<
    subroutine assign_values_broadcast(from, nfrom, to, nto)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: from
        integer(C_INT), value, intent(IN) :: nfrom
        integer(C_INT), intent(INOUT) :: to(:)
        integer(C_INT), value, intent(IN) :: nto
        ! splicer begin function.assign_values_broadcast
        call c_assign_values_broadcast(from, nfrom, to, nto)
        ! splicer end function.assign_values_broadcast
    end subroutine assign_values_broadcast

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void AssignValues
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  const int * from +rank(1)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nfrom +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int * to +rank(1)
    ! Attrs:     +intent(inout)
    ! Requested: f_inout_native_*
    ! Match:     f_default
    ! Attrs:     +intent(inout)
    ! Requested: c_inout_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  int nto +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    !>
    !! Broadcast if nfrom == 1
    !! Copy if nfrom == nto
    !<
    subroutine assign_values_copy(from, nfrom, to, nto)
        use iso_c_binding, only : C_INT
        integer(C_INT), intent(IN) :: from(:)
        integer(C_INT), value, intent(IN) :: nfrom
        integer(C_INT), intent(INOUT) :: to(:)
        integer(C_INT), value, intent(IN) :: nto
        ! splicer begin function.assign_values_copy
        call c_assign_values_copy(from, nfrom, to, nto)
        ! splicer end function.assign_values_copy
    end subroutine assign_values_copy

#if 1
    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void SavePointer
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(1)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    subroutine save_pointer_float1d(addr)
        use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
        real(C_FLOAT), intent(IN) :: addr(:)
        integer(C_INT) :: SH_type
        integer(C_SIZE_T) :: SH_size
        ! splicer begin function.save_pointer_float1d
        SH_type = T_FLOAT
        SH_size = size(addr,kind=C_SIZE_T)
        call c_save_pointer_float1d(addr, SH_type, SH_size)
        ! splicer end function.save_pointer_float1d
    end subroutine save_pointer_float1d
#endif

#if 1
    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void SavePointer
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(2)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    subroutine save_pointer_float2d(addr)
        use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
        real(C_FLOAT), intent(IN) :: addr(:,:)
        integer(C_INT) :: SH_type
        integer(C_SIZE_T) :: SH_size
        ! splicer begin function.save_pointer_float2d
        SH_type = T_FLOAT
        SH_size = size(addr,kind=C_SIZE_T)
        call c_save_pointer_float2d(addr, SH_type, SH_size)
        ! splicer end function.save_pointer_float2d
    end subroutine save_pointer_float2d
#endif

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void SavePointer2
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(1)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    subroutine save_pointer2_float1d(addr)
        use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
        real(C_FLOAT), intent(IN) :: addr(:)
        integer(C_INT) :: SH_type
        integer(C_SIZE_T) :: SH_size
        ! splicer begin function.save_pointer2_float1d
        SH_type = SH_TYPE_FLOAT
        SH_size = size(addr,kind=C_SIZE_T)
        call c_save_pointer2_float1d(addr, SH_type, SH_size)
        ! splicer end function.save_pointer2_float1d
    end subroutine save_pointer2_float1d

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  void SavePointer2
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * addr +intent(in)+rank(2)
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_*
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_*
    ! Match:     c_default
    subroutine save_pointer2_float2d(addr)
        use iso_c_binding, only : C_FLOAT, C_INT, C_SIZE_T
        real(C_FLOAT), intent(IN) :: addr(:,:)
        integer(C_INT) :: SH_type
        integer(C_SIZE_T) :: SH_size
        ! splicer begin function.save_pointer2_float2d
        SH_type = SH_TYPE_FLOAT
        SH_size = size(addr,kind=C_SIZE_T)
        call c_save_pointer2_float2d(addr, SH_type, SH_size)
        ! splicer end function.save_pointer2_float2d
    end subroutine save_pointer2_float2d

#if 0
    ! Only the interface is needed
    ! ----------------------------------------
    ! Function:  void GetPointer
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  void * * addr +intent(out)
    ! Attrs:     +intent(out)
    ! Exact:     f_out_void_**
    ! Attrs:     +intent(out)
    ! Exact:     c_out_void_**
    ! ----------------------------------------
    ! Argument:  int * type +intent(out)
    ! Attrs:     +intent(out)
    ! Exact:     f_out_native_*
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    ! ----------------------------------------
    ! Argument:  size_t * size +intent(out)
    ! Attrs:     +intent(out)
    ! Exact:     f_out_native_*
    ! Attrs:     +intent(out)
    ! Requested: c_out_native_*
    ! Match:     c_default
    subroutine get_pointer(addr, type, size)
        use iso_c_binding, only : C_INT, C_PTR, C_SIZE_T
        type(C_PTR), intent(OUT) :: addr
        integer(C_INT), intent(OUT) :: type
        integer(C_SIZE_T), intent(OUT) :: size
        ! splicer begin function.get_pointer
        call c_get_pointer(addr, type, size)
        ! splicer end function.get_pointer
    end subroutine get_pointer
#endif

#if 0
    ! Generated by fortran_generic - arg_to_buffer
    ! ----------------------------------------
    ! Function:  void GetPointerAsPointer
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * * addr +deref(pointer)+intent(out)+rank(1)
    ! Attrs:     +deref(pointer)+intent(out)
    ! Exact:     f_out_native_**_cdesc_pointer
    ! Attrs:     +api(cdesc)+deref(pointer)+intent(out)
    ! Requested: c_out_native_**_cdesc_pointer
    ! Match:     c_out_native_**_cdesc
    subroutine get_pointer_as_pointer_float1d(addr)
        use iso_c_binding, only : C_FLOAT, c_f_pointer
        real(C_FLOAT), intent(OUT), pointer :: addr(:)
        ! splicer begin function.get_pointer_as_pointer_float1d
        type(GEN_SHROUD_array) :: SHT_addr_cdesc
        call c_get_pointer_as_pointer_float1d_bufferify(SHT_addr_cdesc)
        call c_f_pointer(SHT_addr_cdesc%base_addr, addr)
        ! splicer end function.get_pointer_as_pointer_float1d
    end subroutine get_pointer_as_pointer_float1d
#endif

#if 0
    ! Generated by fortran_generic - arg_to_buffer
    ! ----------------------------------------
    ! Function:  void GetPointerAsPointer
    ! Attrs:     +intent(subroutine)
    ! Exact:     f_subroutine
    ! Attrs:     +intent(subroutine)
    ! Exact:     c_subroutine
    ! ----------------------------------------
    ! Argument:  float * * addr +deref(pointer)+intent(out)+rank(2)
    ! Attrs:     +deref(pointer)+intent(out)
    ! Exact:     f_out_native_**_cdesc_pointer
    ! Attrs:     +api(cdesc)+deref(pointer)+intent(out)
    ! Requested: c_out_native_**_cdesc_pointer
    ! Match:     c_out_native_**_cdesc
    subroutine get_pointer_as_pointer_float2d(addr)
        use iso_c_binding, only : C_FLOAT, c_f_pointer
        real(C_FLOAT), intent(OUT), pointer :: addr(:,:)
        ! splicer begin function.get_pointer_as_pointer_float2d
        type(GEN_SHROUD_array) :: SHT_addr_cdesc
        call c_get_pointer_as_pointer_float2d_bufferify(SHT_addr_cdesc)
        call c_f_pointer(SHT_addr_cdesc%base_addr, addr)
        ! splicer end function.get_pointer_as_pointer_float2d
    end subroutine get_pointer_as_pointer_float2d
#endif

    ! ----------------------------------------
    ! Function:  StructAsClass * CreateStructAsClass
    ! Attrs:     +api(capptr)+intent(function)
    ! Exact:     f_function_shadow_*_capptr
    ! Attrs:     +api(capptr)+intent(function)
    ! Exact:     c_function_shadow_*_capptr
    function create_struct_as_class() &
            result(SHT_rv)
        use iso_c_binding, only : C_PTR
        type(struct_as_class) :: SHT_rv
        type(C_PTR) :: SHT_prv
        ! splicer begin function.create_struct_as_class
        SHT_prv = c_create_struct_as_class(SHT_rv%cxxmem)
        ! splicer end function.create_struct_as_class
    end function create_struct_as_class

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  long UpdateStructAsClass
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  StructAsClass * arg
    ! Attrs:     +intent(inout)
    ! Requested: f_inout_shadow_*
    ! Match:     f_default
    ! Attrs:     +intent(inout)
    ! Exact:     c_inout_shadow_*
    ! ----------------------------------------
    ! Argument:  int inew +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    function update_struct_as_class_int(arg, inew) &
            result(SHT_rv)
        use iso_c_binding, only : C_INT, C_LONG
        type(struct_as_class), intent(INOUT) :: arg
        integer(C_INT), value, intent(IN) :: inew
        integer(C_LONG) :: SHT_rv
        ! splicer begin function.update_struct_as_class_int
        SHT_rv = c_update_struct_as_class_int(arg%cxxmem, inew)
        ! splicer end function.update_struct_as_class_int
    end function update_struct_as_class_int

    ! Generated by fortran_generic
    ! ----------------------------------------
    ! Function:  long UpdateStructAsClass
    ! Attrs:     +intent(function)
    ! Requested: f_function_native_scalar
    ! Match:     f_function
    ! Attrs:     +intent(function)
    ! Requested: c_function_native_scalar
    ! Match:     c_function
    ! ----------------------------------------
    ! Argument:  StructAsClass * arg
    ! Attrs:     +intent(inout)
    ! Requested: f_inout_shadow_*
    ! Match:     f_default
    ! Attrs:     +intent(inout)
    ! Exact:     c_inout_shadow_*
    ! ----------------------------------------
    ! Argument:  long inew +value
    ! Attrs:     +intent(in)
    ! Requested: f_in_native_scalar
    ! Match:     f_default
    ! Attrs:     +intent(in)
    ! Requested: c_in_native_scalar
    ! Match:     c_default
    function update_struct_as_class_long(arg, inew) &
            result(SHT_rv)
        use iso_c_binding, only : C_LONG
        type(struct_as_class), intent(INOUT) :: arg
        integer(C_LONG), value, intent(IN) :: inew
        integer(C_LONG) :: SHT_rv
        ! splicer begin function.update_struct_as_class_long
        SHT_rv = c_update_struct_as_class_long(arg%cxxmem, inew)
        ! splicer end function.update_struct_as_class_long
    end function update_struct_as_class_long

    ! splicer begin additional_functions
    ! splicer end additional_functions

    function struct_as_class_eq(a,b) result (rv)
        use iso_c_binding, only: c_associated
        type(struct_as_class), intent(IN) ::a,b
        logical :: rv
        if (c_associated(a%cxxmem%addr, b%cxxmem%addr)) then
            rv = .true.
        else
            rv = .false.
        endif
    end function struct_as_class_eq

    function struct_as_class_ne(a,b) result (rv)
        use iso_c_binding, only: c_associated
        type(struct_as_class), intent(IN) ::a,b
        logical :: rv
        if (.not. c_associated(a%cxxmem%addr, b%cxxmem%addr)) then
            rv = .true.
        else
            rv = .false.
        endif
    end function struct_as_class_ne

end module generic_mod
