// wrapstatement.cpp
// This file is generated by Shroud nowrite-version. Do not edit.
// Copyright (c) 2017-2023, Lawrence Livermore National Security, LLC and
// other Shroud Project Developers.
// See the top-level COPYRIGHT file for details.
//
// SPDX-License-Identifier: (BSD-3-Clause)
//

// cxx_header
#include "statement.hpp"
// typemap
#include <string>
// shroud
#include <cstring>
#include "wrapstatement.h"

// splicer begin CXX_definitions
// splicer end CXX_definitions

extern "C" {


// helper ShroudStrCopy
// Copy src into dest, blank fill to ndest characters
// Truncate if dest is too short.
// dest will not be NULL terminated.
static void ShroudStrCopy(char *dest, int ndest, const char *src, int nsrc)
{
   if (src == NULL) {
     std::memset(dest,' ',ndest); // convert NULL pointer to blank filled string
   } else {
     if (nsrc < 0) nsrc = std::strlen(src);
     int nm = nsrc < ndest ? nsrc : ndest;
     std::memcpy(dest,src,nm);
     if(ndest > nm) std::memset(dest+nm,' ',ndest-nm); // blank fill
   }
}
// splicer begin C_definitions
// splicer end C_definitions

/**
 * \brief helper function for Fortran to get length of name.
 *
 */
// ----------------------------------------
// Function:  int GetNameLength +pure
// Attrs:     +intent(function)
// Requested: c_function_native_scalar
// Match:     c_function
int STMT_GetNameLength(void)
{
    // splicer begin function.GetNameLength
    return getNameErrorPattern().length();
    // splicer end function.GetNameLength
}

// ----------------------------------------
// Function:  const string & getNameErrorPattern +len(get_name_length())
// Attrs:     +deref(copy)+intent(function)
// Requested: c_function_string_&_copy
// Match:     c_function_string_&
const char * STMT_getNameErrorPattern(void)
{
    // splicer begin function.getNameErrorPattern
    const std::string & SHCXX_rv = getNameErrorPattern();
    // C_error_pattern
    if (! isNameValid(SHCXX_rv)) {
        return NULL;
    }

    const char * SHC_rv = SHCXX_rv.c_str();
    return SHC_rv;
    // splicer end function.getNameErrorPattern
}

// ----------------------------------------
// Function:  const string & getNameErrorPattern +len(get_name_length())
// Attrs:     +api(buf)+deref(copy)+intent(function)
// Requested: c_function_string_&_buf_copy
// Match:     c_function_string_&_buf
void STMT_getNameErrorPattern_bufferify(char *SHC_rv, int SHT_rv_len)
{
    // splicer begin function.getNameErrorPattern_bufferify
    const std::string & SHCXX_rv = getNameErrorPattern();
    if (SHCXX_rv.empty()) {
        ShroudStrCopy(SHC_rv, SHT_rv_len, nullptr, 0);
    } else {
        ShroudStrCopy(SHC_rv, SHT_rv_len, SHCXX_rv.data(),
            SHCXX_rv.size());
    }
    // splicer end function.getNameErrorPattern_bufferify
}

}  // extern "C"
